## gr-rds 3.10

=== CMakeLists.txt ===
# Copyright 2021 Bastian Bloessl <mail@bastibl.net>
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-rds
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 3.8)
project(gr-rds CXX C)
enable_testing()

# Install to PyBOMBS target prefix if defined
if(DEFINED ENV{PYBOMBS_PREFIX})
    set(CMAKE_INSTALL_PREFIX $ENV{PYBOMBS_PREFIX})
    message(STATUS "PyBOMBS installed GNU Radio. Setting CMAKE_INSTALL_PREFIX to $ENV{PYBOMBS_PREFIX}")
endif()

# Select the release build type by default to get optimization flags
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
   message(STATUS "Build type not specified: defaulting to release.")
endif(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "")

# Make sure our local CMake Modules path comes first
list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_SOURCE_DIR}/cmake/Modules)

# Set the version information here
set(VERSION_MAJOR 1)
set(VERSION_API    1)
set(VERSION_ABI 0)
set(VERSION_PATCH git)

cmake_policy(SET CMP0011 NEW)

# Enable generation of compile_commands.json for code completion engines
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

########################################################################
# Compiler specific setup
########################################################################
if((CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
    CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    AND NOT WIN32)
    #http://gcc.gnu.org/wiki/Visibility
    add_definitions(-fvisibility=hidden)
endif()

IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    SET(CMAKE_CXX_STANDARD 14)
ELSEIF(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    SET(CMAKE_CXX_STANDARD 14)
ELSEIF(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    SET(CMAKE_CXX_STANDARD 14)
ELSE()
    message(WARNING "C++ standard could not be set because compiler is not GNU, Clang or MSVC.")
ENDIF()

IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    SET(CMAKE_C_STANDARD 11)
ELSEIF(CMAKE_C_COMPILER_ID MATCHES "Clang")
    SET(CMAKE_C_STANDARD 11)
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
    SET(CMAKE_C_STANDARD 11)
ELSE()
    message(WARNING "C standard could not be set because compiler is not GNU, Clang or MSVC.")
ENDIF()

########################################################################
# Install directories
########################################################################
include(FindPkgConfig)
find_package(Gnuradio "3.10" REQUIRED)
include(GrVersion)

include(GrPlatform) #define LIB_SUFFIX

if(NOT CMAKE_MODULES_DIR)
  set(CMAKE_MODULES_DIR lib${LIB_SUFFIX}/cmake)
endif(NOT CMAKE_MODULES_DIR)

set(GR_INCLUDE_DIR      include/rds)
set(GR_CMAKE_DIR        ${CMAKE_MODULES_DIR}/rds)
set(GR_PKG_DATA_DIR     ${GR_DATA_DIR}/${CMAKE_PROJECT_NAME})
set(GR_PKG_DOC_DIR      ${GR_DOC_DIR}/${CMAKE_PROJECT_NAME})
set(GR_PKG_CONF_DIR     ${GR_CONF_DIR}/${CMAKE_PROJECT_NAME}/conf.d)
set(GR_PKG_LIBEXEC_DIR  ${GR_LIBEXEC_DIR}/${CMAKE_PROJECT_NAME})

########################################################################
# On Apple only, set install name and use rpath correctly, if not already set
########################################################################
if(APPLE)
    if(NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR
            ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR} CACHE
            PATH "Library Install Name Destination Directory" FORCE)
    endif(NOT CMAKE_INSTALL_NAME_DIR)
    if(NOT CMAKE_INSTALL_RPATH)
        set(CMAKE_INSTALL_RPATH
            ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR} CACHE
            PATH "Library Install RPath" FORCE)
    endif(NOT CMAKE_INSTALL_RPATH)
    if(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
        set(CMAKE_BUILD_WITH_INSTALL_RPATH ON CACHE
            BOOL "Do Build Using Library Install RPath" FORCE)
    endif(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
endif(APPLE)

########################################################################
# Find gnuradio build dependencies
########################################################################
find_package(Doxygen)
find_package(Boost 1.40 COMPONENTS locale REQUIRED)

########################################################################
# PyBind11 Related
########################################################################

find_package(pybind11 REQUIRED)
execute_process(
    COMMAND "${PYTHON_EXECUTABLE}" -c
    "try:\n import numpy\n import os\n inc_path = numpy.get_include()\n if os.path.exists(os.path.join(inc_path, 'numpy', 'arrayobject.h')):\n  print(inc_path, end='')\nexcept:\n pass"
    OUTPUT_VARIABLE PYTHON_NUMPY_INCLUDE_DIR)
# format path in CMake-style for consistency with other path variables
# (a consistent style helps conda builds by using the same path separators)
file(TO_CMAKE_PATH "${PYTHON_NUMPY_INCLUDE_DIR}" PYTHON_NUMPY_INCLUDE_DIR)

########################################################################
# Setup doxygen option
########################################################################
if(DOXYGEN_FOUND)
    option(ENABLE_DOXYGEN "Build docs using Doxygen" ON)
else(DOXYGEN_FOUND)
    option(ENABLE_DOXYGEN "Build docs using Doxygen" OFF)
endif(DOXYGEN_FOUND)

########################################################################
# Create uninstall target
########################################################################
configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

add_custom_target(uninstall
    ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
    )

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(include/rds)
add_subdirectory(lib)
add_subdirectory(docs)
# NOTE: manually update below to use GRC to generate C++ flowgraphs w/o python
if(ENABLE_PYTHON)
  message(STATUS "PYTHON and GRC components are enabled")
  add_subdirectory(python)
  add_subdirectory(grc)
else(ENABLE_PYTHON)
  message(STATUS "PYTHON and GRC components are disabled")
endif(ENABLE_PYTHON)

########################################################################
# Install cmake search helper for this library
########################################################################

install(FILES cmake/Modules/rdsConfig.cmake
    DESTINATION ${CMAKE_MODULES_DIR}/rds
)

=== docs/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-rds
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################
find_package(Doxygen)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_DOXYGEN)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(doxygen)

endif(ENABLE_DOXYGEN)

=== grc/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-rds
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

install(FILES
    rds_decoder.block.yml
    rds_encoder.block.yml
    rds_panel.block.yml
    rds_parser.block.yml DESTINATION share/gnuradio/grc/blocks
)

=== lib/CMakeLists.txt ===
# Copyright 2021 Bastian Bloessl <mail@bastibl.net>
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-rds
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup library
########################################################################
include(GrPlatform) #define LIB_SUFFIX

list(APPEND rds_sources
    decoder_impl.cc
    encoder_impl.cc
    parser_impl.cc
)

set(rds_sources "${rds_sources}" PARENT_SCOPE)
if(NOT rds_sources)
    MESSAGE(STATUS "No C++ sources... skipping lib/")
    return()
endif(NOT rds_sources)

add_library(gnuradio-rds SHARED ${rds_sources})
target_link_libraries(gnuradio-rds gnuradio::gnuradio-runtime ${Boost_LIBRARIES})
target_include_directories(gnuradio-rds
    PUBLIC ${Boost_INCLUDE_DIR}
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
    PUBLIC $<INSTALL_INTERFACE:include>
  )
set_target_properties(gnuradio-rds PROPERTIES DEFINE_SYMBOL "gnuradio_rds_EXPORTS")

if(APPLE)
    set_target_properties(gnuradio-rds PROPERTIES
        INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
    )
endif(APPLE)

########################################################################
# Install built library files
########################################################################
include(GrMiscUtils)
set(VERSION "1.1.0")
set(LIBVER "1")
GR_LIBRARY_FOO(gnuradio-rds)

########################################################################
# Print summary
########################################################################
message(STATUS "Using install prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Building for version: ${VERSION} / ${LIBVER}")

########################################################################
# Build and register unit test
########################################################################
include(GrTest)

# If your unit tests require special include paths, add them here
#include_directories()
# List all files that contain Boost.UTF unit tests here
list(APPEND test_rds_sources
)
# Anything we need to link to for the unit tests go here
list(APPEND GR_TEST_TARGET_DEPS gnuradio-rds)

if(NOT test_rds_sources)
    MESSAGE(STATUS "No C++ unit tests... skipping")
    return()
endif(NOT test_rds_sources)

foreach(qa_file ${test_rds_sources})
    GR_ADD_CPP_TEST("rds_${qa_file}"
        ${CMAKE_CURRENT_SOURCE_DIR}/${qa_file}
    )
endforeach(qa_file)

=== python/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-rds
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Include python install macros
########################################################################
include(GrPython)
if(NOT PYTHONINTERP_FOUND)
    return()
endif()

add_subdirectory(bindings)

########################################################################
# Install python sources
########################################################################
GR_PYTHON_INSTALL(
    FILES
    __init__.py
    rdspanel.py
    DESTINATION ${GR_PYTHON_DIR}/rds
)

########################################################################
# Handle the unit tests
########################################################################
include(GrTest)

set(GR_TEST_TARGET_DEPS gnuradio-rds)

=== include/rds/CMakeLists.txt ===
#
#  Copyright (C) 2014 Bastian Bloessl <bloessl@ccs-labs.org>
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Install public header files
########################################################################
install(FILES
    api.h
    decoder.h
    encoder.h
    parser.h DESTINATION include/rds
)

=== python/bindings/CMakeLists.txt ===
# Copyright 2020 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Check if there is C++ code at all
########################################################################
if(NOT rds_sources)
    MESSAGE(STATUS "No C++ sources... skipping python bindings")
    return()
endif(NOT rds_sources)

########################################################################
# Check for pygccxml
########################################################################
GR_PYTHON_CHECK_MODULE_RAW(
    "pygccxml"
    "import pygccxml"
    PYGCCXML_FOUND
    )

include(GrPybind)

########################################################################
# Python Bindings
########################################################################

list(APPEND rds_python_files
    decoder_python.cc
    encoder_python.cc
    parser_python.cc
    python_bindings.cc)

GR_PYBIND_MAKE_OOT(rds 
   ../..
   gr::rds
   "${rds_python_files}")

install(TARGETS rds_python DESTINATION ${GR_PYTHON_DIR}/rds COMPONENT pythonapi)

=== debian/changelog ===
gr-rds (3.10-1build20) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 12 Aug 2025 10:25:02 +0200

gr-rds (3.10-1build19) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 08 Aug 2025 05:34:33 +0200

gr-rds (3.10-1build18) questing; urgency=medium

  * Rebuild against latest gnuradio

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 03 May 2025 11:55:40 -0400

gr-rds (3.10-1build17) plucky; urgency=medium

  * No-change rebuild against python3-numpy2-abi0

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 30 Jan 2025 14:46:29 +0000

gr-rds (3.10-1build16) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 04 Jan 2025 06:05:45 +0100

gr-rds (3.10-1build15) oracular; urgency=medium

  * No-change rebuild for gnuradio-3.10.11.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 26 Jul 2024 08:13:08 +0100

gr-rds (3.10-1build14) oracular; urgency=high

  * No change rebuild against gnuradio.

 -- Julian Andres Klode <juliank@ubuntu.com>  Tue, 14 May 2024 10:25:37 +0200

gr-rds (3.10-1build13) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:20:37 +0000

gr-rds (3.10-1build12) noble; urgency=medium

  * No-change rebuild against gnuradio t64.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 22 Mar 2024 02:41:01 +0100

gr-rds (3.10-1build11) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 21 Jan 2024 07:41:04 +0000

gr-rds (3.10-1build10) noble; urgency=medium

  * No-change rebuild for gnuradio soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 03 Jan 2024 11:44:47 +0100

gr-rds (3.10-1build9) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Dec 2023 23:15:38 +0100

gr-rds (3.10-1build8) noble; urgency=medium

  * Rebuild against latest gnuradio

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 30 Oct 2023 07:35:29 -0400

gr-rds (3.10-1build7) noble; urgency=medium

  * Rebuild against latest gnuradio

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 30 Oct 2023 07:35:22 -0400

gr-rds (3.10-1build6) mantic; urgency=medium

  * Rebuild against new gnuradion 3.10.7.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 01 Sep 2023 11:24:45 +0200

gr-rds (3.10-1build5) lunar; urgency=medium

  * No-change rebuild with Python 3.11 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 27 Dec 2022 03:38:53 +0000

gr-rds (3.10-1build4) lunar; urgency=medium

  * No-change rebuild with gnuradio 3.10.4

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 18 Nov 2022 13:52:42 -0300

gr-rds (3.10-1build3) kinetic; urgency=medium

  * No-change rebuild against libgnuradio-runtime3.10.3

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Jul 2022 17:54:52 +0000

gr-rds (3.10-1build2) kinetic; urgency=medium

  * No-change rebuild against libgnuradio-runtime3.10.2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 20 May 2022 01:04:34 +0000

gr-rds (3.10-1build1) jammy; urgency=medium

  * No-change rebuild against gnuradio 3.10.1

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 08 Feb 2022 13:59:52 +0000

gr-rds (3.10-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 20 Jan 2022 22:33:05 -0500

=== debian/control ===
Source: gr-rds
Section: libdevel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
	       dh-python,
	       doxygen,
               gnuradio-dev (>=3.9),
	       graphviz,
	       libboost-dev,
	       libboost-locale-dev,
	       libboost-regex-dev,
	       libboost-system-dev,
               pkg-config,
	       python3-dev,
	       python3-numpy,
               python3-pybind11
Standards-Version: 4.6.0
Homepage: https://github.com/bastibl/gr-rds
Vcs-Browser: https://salsa.debian.org/bottoms/pkg-gr-rds
Vcs-Git: https://salsa.debian.org/bottoms/pkg-gr-rds.git

Package: gr-rds
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${python3:Depends}, gnuradio-dev,
         libgnuradio-rds1  (=${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: GNU Radio FM RDS/TMC Transceiver
 A Radio Data System - Traffic Message Channel (RDS-TMC) block
 for GNU Radio.
 .
 Radio Data System (RDS) is a communications protocol standard for
 embedding  small amounts of digital information in conventional
 FM radio broadcasts.
 .
 gr-rds provides GNU Radio Companion flowgraphs to handle RDS data.
 
Package: libgnuradio-rds1
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gr-rds
Description: GNU Radio FM RDS/TMC Transceiver (library)
 A Radio Data System - Traffic Message Channel (RDS-TMC) block
 for GNU Radio.
 .
 Radio Data System (RDS) is a communications protocol standard for
 embedding  small amounts of digital information in conventional
 FM radio broadcasts.
 .
 This package provides a shared library.

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH

%:
	dh $@ --with python3 --with numpy3

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DCMAKE_BUILD_TYPE="Release"

override_dh_auto_install:
	dh_auto_install
	rm -f debian/tmp/usr/lib/python3/dist-packages/rds/*pyc
	rm -f debian/tmp/usr/lib/python3/dist-packages/rds/*pyo
